@echo off
REM -- This is GRABWTHR.BAT  version 1.1
rem -- Adds recognition for several unusual forecast codes that I hadn't
rem -- previously figured out, viz., "Fair," "Mostly Cloudy,"
rem -- and "Windy."

rem -- If your PointCast weather files are in a directory/folder
rem -- other than this one:

copy "C:\Program Files\PointCast\weather\wcity2.lst" wthrcopy.tmp

rem -- then edit the quoted part of the line above to reflect 
rem -- your particular directory/folder location.


rem ----- here's a typical first line in the file "wcity2.lst":
rem (PREAMBLE,"Forecasts on",864820800,"May 28 1997, 8:00AM Eastern")
rem ----- And here are some typical data lines:
rem (L,"Cheyenne, WY")(0,,,57,42,2,)(1,,,60,39,2,)(2,,,65,42,2,)(3,,,65,42,2,)
rem (L,"Chicago (Midway), IL")(0,,,64,54,0,)(1,,,60,54,8,)(2,,,64,49,8,)(3,,,69,51,2,)
rem (L,"Chicago (O'Hare), IL")(0,,,64,47,2,)(1,,,60,50,8,)(2,,,66,52,8,)(3,,,69,51,2,)
rem (L,"Cincinnati, OH")(0,,,69,51,2,)(1,,,68,57,8,)(2,,,68,54,5,)(3,,,72,53,4,)

rem -- Extract current date from PREAMBLE line and create wther.tmp
mt /xqon+  wthrcopy.tmp  /  "^(PREAMBLE,.*\d{9},\".*\")"  = "\5\r\n\t\tHi\tLo\tConditions\r\n\t\t--\t--\t----------\r\n"  >wthr.tmp

rem -- Change case of AM and PM just because I like it better
mt /xqn+  wthr.tmp  /  "AM" = " am"  "PM" = " pm"  

rem -- Extract city of choice and append to wthr.tmp
rem -- Here's the model: replace them (and add more,
rem -- if you like) with cities of your own choosing.

mt /xoqn+  wthrcopy.tmp  /  "^(L,\"CITY1, STATE.*$" = "\i" >>wthr.tmp
mt /xoqn+  wthrcopy.tmp  /  "^(L,\"CITY2, STATE.*$" = "\i" >>wthr.tmp

rem -- Note that the city name must begin with one leading 
rem -- quote, and the two letter state abbreviation must
rem -- be followed by period-asterisk-dollarsign-quote. 
rem -- Here's a real one:

mt /xoqn+  wthrcopy.tmp  /  "^(L,\"Richmond, VA.*$" = "\i" >>wthr.tmp

rem -- Double names ("New York") can't be passed as a parameter 
rem -- in the CITYLIST.BAT file unless you use the backslash-s convention
rem -- (see the CITYLIST.BAT file). Alternatively, you can use the city names
rem -- here. The following list just shows some of the many double names. 
rem -- If you want to use any of these, just strip off the "rem -- " at 
rem -- the beginning of the line. 

rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"Las Cruces, NM.*$" = "\i" >>wthr.tmp
rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"Las Vegas, NV.*$" = "\i" >>wthr.tmp
rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"Los Angeles, CA.*$" = "\i" >>wthr.tmp

rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"New York (JFK), NY.*$" = "\i" >>wthr.tmp
rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"New York (LGA), NY.*$" = "\i" >>wthr.tmp
rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"New Orleans, LA.*$" = "\i" >>wthr.tmp


rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"San Angelo, TX.*$" = "\i" >>wthr.tmp
rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"San Antonio, TX.*$" = "\i" >>wthr.tmp
rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"San Diego, CA.*$" = "\i" >>wthr.tmp
rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"San Francisco, CA.*$" = "\i" >>wthr.tmp
rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"San Jose, CA.*$" = "\i" >>wthr.tmp
rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"San Juan, PR.*$" = "\i" >>wthr.tmp
rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"San Luis Obispo, CA.*$" = "\i" >>wthr.tmp
rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"Santa Barbara, CA.*$" = "\i" >>wthr.tmp
rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"Santa Fe, NM.*$" = "\i" >>wthr.tmp
rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"Santa Maria, CA.*$" = "\i" >>wthr.tmp

rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"Sioux City, IA.*$" = "\i" >>wthr.tmp
rem -- mt /xoqn+  wthrcopy.tmp  /  "^(L,\"Sioux Falls, SD.*$" = "\i" >>wthr.tmp



rem -- Here are the city names passed as parameters from
rem -- the CITYLIST.BAT file. 

if (%1) == () goto NEXT
mt /xoqn+  wthrcopy.tmp  /  "^(L,\"%1.*$" = "\i" >>wthr.tmp
if (%2) == () goto NEXT
mt /xoqn+  wthrcopy.tmp  /  "^(L,\"%2.*$" = "\i" >>wthr.tmp
if (%3) == () goto NEXT
mt /xoqn+  wthrcopy.tmp  /  "^(L,\"%3.*$" = "\i" >>wthr.tmp
if (%4) == () goto NEXT
mt /xoqn+  wthrcopy.tmp  /  "^(L,\"%4.*$" = "\i" >>wthr.tmp
if (%5) == () goto NEXT
mt /xoqn+  wthrcopy.tmp  /  "^(L,\"%5.*$" = "\i" >>wthr.tmp
if (%6) == () goto NEXT
mt /xoqn+  wthrcopy.tmp  /  "^(L,\"%6.*$" = "\i" >>wthr.tmp
if (%7) == () goto NEXT
mt /xoqn+  wthrcopy.tmp  /  "^(L,\"%7.*$" = "\i" >>wthr.tmp
if (%8) == () goto NEXT
mt /xoqn+  wthrcopy.tmp  /  "^(L,\"%8.*$" = "\i" >>wthr.tmp
if (%9) == () goto NEXT
mt /xoqn+  wthrcopy.tmp  /  "^(L,\"%9.*$" = "\i" >>wthr.tmp

:NEXT


rem -- For some reason some of the line breaks 
rem -- at this point have two CRs and one LF, so let's fix it:
mt /xqn+  wthr.tmp  /  "\r\r\n" =  "\r\n"


rem -- Now decode the weather forecasts

mt /xqn+  wthr.tmp  /  ",0,)" = "\tSunny\r\n" 
mt /xqn+  wthr.tmp  /  ",1,)" = "\tFair\r\n" 
mt /xqn+  wthr.tmp  /  ",2,)" = "\tPartly Cloudy\r\n" 
mt /xqn+  wthr.tmp  /  ",3,)" = "\tMostly Cloudy\r\n"
mt /xqn+  wthr.tmp  /  ",4,)" = "\tCloudy\r\n" 
mt /xqn+  wthr.tmp  /  ",5,)" = "\tT-Storms\r\n"
mt /xqn+  wthr.tmp  /  ",6,)" = "\tWindy\r\n" 
mt /xqn+  wthr.tmp  /  ",7.)" = "\tRain\r\n"
mt /xqn+  wthr.tmp  /  ",8,)" = "\tShowers\r\n" 
mt /xqn+  wthr.tmp  /  ",9,)" = "\tSnow!\r\n"
mt /xqn+  wthr.tmp  /  "(-1,,,\d{1,3},\d{1,3}" = "...yda\t\2\t\4" 
mt /xqn+  wthr.tmp  /  "(0,,,\d{1,3},\d{1,3}" = "TODAY\t\2\t\4"
mt /xqn+  wthr.tmp  /  "(1,,,\d{1,3},\d{1,3}" = "Tmro\t\2\t\4" 
mt /xqn+  wthr.tmp  /  "(2,,,\d{1,3},\d{1,3}" = "Next\t\2\t\4" 
mt /xqn+  wthr.tmp  /  "(3,,,\d{1,3},\d{1,3}" = "After\t\2\t\4"


rem -- Delete the stuff surrounding city names and insert
rem -- special characters for a DOC bookmark.
rem -- I use three spaces as the bookmark because it
rem -- looks better on screen than two. But YMMV.
rem -- They don't even have to be spaces, for that matter.
mt /xqn+  wthr.tmp  /  "^(L,\".*\")" = "   \2\r\n"   
rem -- Here are the three spaces:       ^^^

rem -- Add the DOC "autobookmark" indicator: whatever appears
rem -- at the end of the file between angle brackets is treated
rem -- by DOC as an autobookmark indicator. I put the actual
rem -- text in a separate file so I can include the spaces. 
type autobook.txt >>wthr.tmp

rem -- And convert to DOC format with MAKEDOC.EXE
makedoc wthr.tmp wthr.pdb  Weather


rem -- If you have a batch install program
rem -- you can install the WTHR.PDB file right now. 
rem -- I use PINSTALL.EXE
rem -- pinstall wthr.pdb

rem -- Now clean up a bit (remove the leading "rem -- " if you want 
rem -- the deletions to take effect:)
rem -- del *.tmp
rem -- del wthr.pdb

rem -- That's it!
:END

